package Fibre::Discover;
use Util;
use Util::Http;
use System;
use FibreStat;
use Data::Dumper;
use strict;
use TO;

#lnk fail    sync loss   signal loss   sequence err   invalid word   CRC

sub discover {
  my($q, $post, $util) = @_;
  my($x);
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;
  $TO::DEVS = $devs;

  if ($q->{ACTION} eq "Submit") {
     &discover1($q);
     return;
  } 
  my($VAR1);
  open(O,  System->get_home() . "/DATA/tmp/discover_dates");
  my(@a) = <O>; close(O);
  eval "@a";

  print "<table border=0><tr><td></table>";
  print "<table border=1 cellspacing=0 width=95% bgcolor=white>
    <form><input type=hidden name=GO value=FibreGUI::test2>
    <input type=hidden name=option value=8>
    <tr bgcolor=#666699><td colspan=5><b><font color=white>Select Hosts to discover</td>
    <tr bgcolor=#E0E0E0>
         <th>Select
         <th>HostName<th>HostID<th>HostIP</td><th width=10%>Last-Run</th>
    ";

  my($url) = "<input type=checkbox name=ck_local>";
  print "<tr><td><center>$url<td>&nbsp;" . System->hostname . "<td>" . System->hostid() . "<td>" . System->local_ip . "</td><td>$VAR1->{local}";

  for ($x=0; $x <= $#$hosts; $x++) {
     my($h) =  $hosts->[$x];
     $url = "<input type=checkbox name=ck_$x>";
     print "<tr><td><center>$url<td>&nbsp;$h->{hostname}<td>$h->{hostid}<td>$h->{ip}</td><td>$VAR1->{$h->{hostname}}";
  }
  print "</table>";
  print "<b>&nbsp;<br>
   <b>Kill stdiscover: <input type=checkbox name=clear>&nbsp;&nbsp;
   <b>TopoName:</b>
   <input type=text name=toponame size=20>
   <input type=submit name=ACTION value=Submit>";
  return;
}

sub discover1 {
  my($q) = @_;
  my($discman, $out, $host);
  my($err, $com, $tot, @com);
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;

  TO::clear();

  my($VAR1);
  open(O,  System->get_home() . "/DATA/tmp/discover_dates");
  my(@a) = <O>; close(O);
  eval "@a";
  foreach my $h (keys %$q) {
     if (substr($h,0,3) eq "ck_") {
        $host = substr($h,3);
        $tot++;
        $com = undef;
        if ($host eq "local") {
           $discman = "/opt/ras/bin/discman.sample";
           $discman = "/opt/SUNWvtsst/bin/sparcv9/discman";
           system("rm /opt/ras/DATA/tmp/luxdisc*");

           if ($q->{clear}) {
              &kill1;
#              print "Run this again in a few seconds without the clear<br>";
#              close(STDIN); close(STDOUT); close(STDERR);
#              system("nohup discman&");
           }
           print "Running discman on $host ...<br>\n";
           ($err,$com) = Util->run_command( "$discman", "invader.discman", 20);
           print "Discman returned $#$com lines<br>";
           if ($#$com < 0 && $q->{clear}) {
              sleep(10);
           }
           print "Err:$err<br>" if ($err);
           $Data::Dumper::Indent = 1;
           $VAR1->{local} = Util->get_today();
           print "Creating Objects ...<br>\n";
        } else {
           # get discman output remotely.
           my($ip) = $hosts->[$host]{ip};
           if ($ip) {
             my($url) = Util->makeUrl($ip, "?GET=Fibre::Discover::discman");
             print "Getting discman from $url...<br>";
             my($data) = Util::Http->get($url, 40);
             @com = split(/\n/, $data);
             print "got $#com lines.<br>";
             $com = \@com;
             $VAR1->{$hosts->[$host]{hostname}} = Util->get_today();
           } else {
             print "No ip for host # $host <br>";
           }
        }
        ($out) = &topo($com) if ($com);
     }
   }
   open(O, ">" . System->get_home() . "/DATA/tmp/discover_dates");
   print O Dumper($VAR1) ;
   close(O);
   if ($tot) {
     TO->writeTopo($q->{toponame} || "data1");
     print "<table border=0 width=100% cellspacing=0 bgcolor=white><tr><td><pre>";
     print &list($q);
     print "</table>";
   } else {
     print "<h2> No host selected!";
   }
}

sub kill1 {
  my($com, $rc);
  my($k) = `/usr/bin/ps -ef | /usr/bin/grep stdiscover | /usr/bin/grep -v grep`;
  $k = Util->trim($k);
  my(@a) = split(/\s+/, $k);
  my($l) =  `/usr/bin/ipcs | /usr/bin/grep 0x7c4`;
  my(@b) = split(/\s+/, $l);
  print "process=$a[1], queue=$b[1]<br>\n";
  if ($a[1]) {
    $com = "/usr/bin/kill $a[1]";
    print "running $com<br>\n";
    $rc = `$com`;
    print $rc;
    sleep(1);
  }
  if ($b[2]) {
    $com = "/usr/bin/ipcrm -q $b[1]";
    print "running $com<br>";
    $rc = `$com`;
    print $rc;
  }

}

sub get_discman {
   my($discman) = "/opt/SUNWvtsst/bin/sparcv9/discman";
   my($err,$com) = Util->run_command( "$discman", "invader.discman", 60);
   print join("\n", @$com);
}
  


#  Run the Topology tab

sub run {
  my($q) = @_;
  print "<table border=0 ><tr><td></table>
        <table border=1 cellspacing=0 cellpadding=0 bgcolor=white> <tr><td>";
  TO->readTopo("data1"); # get objects in globals

  my($applet);
  $applet =<<EOF;
 <script>
  var a_width =  window.innerWidth  - 25;
  var a_height =  window.innerHeight - 70;
  window.document.writeln(
   '<applet  CODE=VertexApplet.class codebase=Topo archive=topo.jar height=' + a_height + ' width=' + a_width + '>');
  </script>
  <param name=url value="GET=Fibre::Discover::topos">
  <param name=urlDetails value="GET=Fibre::Discover::details">
  <param name=browser value="sun">
  </applet>
EOF
  print $applet;

  print "</table>";
}


# when user right click Show in the Topo GUI
sub get_details {
  my($q) = @_;
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;

  TO->readTopo("data1");
  print "<body bgcolor=white>";
  print "<table border=1 cellspacing=0 cellpadding=2 width=100%>
   <tr bgcolor=#666699><td><font color=white><b>System Review: $q->{enc}</td>
   </table><pre>";
  print TO->display($devs, $q->{enc});
}
  

sub get__topos0 {
 my($q) = @_;
  print "\n";
  print <<EOF;
01|v|a,2|encstatus|0|2,2,2,2,2,2,2,2,2,2,2,2|a5k-DSP1|300|20|portInfo|diskInfo0,diskinfo1,diskinfo2,diskinfo3,diskinfo4|aencInfo
02|v|h,3|0|0|0|jumbo|40|20|portInfo0,portinfo1,portinfo2||hencInfo
03|v|s,4,4|0|0|0|Switch2|150|50|portInfo||hendInfo
04|e|f|0|0|0|cable|01,1|03,5||
05|e|f|0|0|0|cable|02,0|03,1||
06|v|a,2|0|0|0|Linda|300|100|portInfo|diskInfo|a2_enc_info
07|e|f|0|0|0|cable|06,1|03,6||
EOF

}

sub get_statusDetails {
 my($q) = @_;
 my($x, $status, $portStatus, $diskStatus, $s, $type, $name );
 my($out) = "";
 TO->readTopo("data1");
 my($cnt) = 1;
 for ($x=0; $x <= $#$TO::Storages; $x++) {
    $s = $TO::Storages->[$x];
    $type = $s->{info}{type};
    $name = $s->{info}{name};
    $status = "0";
    $portStatus = "1/1/1/1/1/1";
    $diskStatus = "1/1/1/1/1/1,2/2/2/2/2/2,3/3/3/3/3/3,4/4/4/4/4/4,5/5/5/5/5/5";
    $out .= "$cnt|v|$type,2|$status|$portStatus|$diskStatus|$name\n";
    $cnt++;
 }
 print $out;

}

sub get_topos {
 my($q) = @_;
 print TO->topos({ status => undef, counters => undef, clear => $q->{clear}});
}


sub put_topos {
 my($q, $post_data) = @_;
 my($topoFile) = $q->{topo} || "data1";
 my($F) = System->get_home() . "/DATA/tmp/topoxy_$topoFile";
  if (open(O, ">$F")) {
    print O "$post_data\n";
    close(O);
    chmod 0666, $F;
    print "\Saved (" . length($post_data) . " bytes)\n";
  } else {
    print "\nERR: $!\n";
  }
}

sub list {
  my($q) = @_;
  my($out, $x);
  for ($x=0; $x <= $#$TO::Hosts; $x++) {
     $out .= TO->hostToString($x);
  }
  for ($x=0; $x <= $#$TO::Switches; $x++) {
     $out .= TO->switchToString($x);
  }
  for ($x=0; $x <= $#$TO::Storages; $x++) {
     $out .= TO->storageToString($x);
  }
  return $out;
}

use vars qw(%hosts  %hbas  %devices);

sub topo {
  my($com) = @_;
  my($out, $l, $x, $hostname, $in, $curr_hba, $curr_dev_cnt, $curr_dev, @a );
  %hosts = %hbas = %devices = ();
  my(@lux) = `luxadm probe -p`;
  my($log);

  my(%MAP1);
  foreach $x (@lux) {
     if ($x =~ /Logical Path:(.*)/) {
           $log = $1;
     } elsif ($x =~ /Physical Path:(.*)/) {
          my($p) = $1;
          my($i) = rindex($p, "/");
          $p = substr($p, 0, $i);
          $MAP1{$p} = "$p,";
     }
  }
  foreach $x (keys %MAP1) {
     print "$x = $MAP1{$x}<br>";
  }

  for ($x=0; $x <= $#$com; $x++ ){
      $l = $com->[$x];
       next if ($l =~ /^\s*$/);
       $l = Util->trim($l);
       if ($l =~ /^\s*Hostname:\s*(.*)/) {
          $hostname = "$1";
          $hosts{$hostname}{type} =  "Sun";
          $hosts{$hostname}{name} =  "h:$hostname";

       } elsif ($l =~ /^\s*Detected.*HBA port\(s\)/) {
          $in = "hbasumm";

       } elsif ($l =~ /^\s*Detected.*FCAL Device\(s\)/) {
          $in = "devicesumm";

       } elsif ($l =~ /^\s*HBA Port (\d+) Path:(.*)/) {
          $in = "hba"; $curr_hba = $1; #sprintf("%2.2d", $1);
          $hbas{$hostname}{$curr_hba}{path} = $2;
          $curr_dev_cnt = -1;

       } elsif ($l =~/^\s*Device # (\d+):\s*$/) {
          $in = "device";
          $curr_dev_cnt++;
          $curr_dev = sprintf("%3.3d", $curr_dev_cnt);

       } elsif ($in eq "hbasumm") {     #  SOCAL HBA port(s):      0

       } elsif ($in eq "devicesumm") {
          @a = split(/\s*:\s*/, $l,2);
          $hosts{$hostname}{$a[0]} .= $a[1] . ",";

       } elsif ($in eq "hba") {
          @a = split(/\s*:\s*/, $l,2);
          $a[1] =~ s/[,\|]/ /g;
          $hbas{$hostname}{$curr_hba}{$a[0]} = $a[1];

       } elsif ($in eq "device") {
          @a = split(/\s*:\s*/, $l,2);
          if (length($a[1]) > 0) {
             $a[1] =~ s/[,\|]/ /g;
             $devices{$hostname}{$curr_hba}{$curr_dev}{$a[0]} = $a[1];
          }
       }
    }
 my(%dp_port, $dinfo, $alpa, $sw_type, $portno, $current_sw, $devs);
 my($dp_port, @DP2OBJ);
 my(%PG, %PGM) ;
 my($host, $hostno, $h, $hinfo , $dp_switch, $current_st, $st_type, $current_hub , $st_port, $new);
 my($ip_port) = -1;
print "</center>";
 foreach $host (sort keys %hosts) {
    $hostno = TO->newHost($host, $hosts{$host});
    
    $out .= "Host: $host $hosts{$host}{type}\n";
    foreach $h (sort keys %{$hbas{$host}}) {
       $dp_port = 0; $dp_switch = -1;
       $out .= "\n[hba-$h ";
       $hinfo = $hbas{$host}{$h};
       
       $TO::Hosts->[$hostno]{port_info}[$h] = $hinfo;
       my(@DP2OBJ) = ();
       if ($hinfo->{al_pa} == -1) {
           $TO::Hosts->[$hostno]{port}[$h] = 0;
           $out .= "not connected]\n";
       } else {
           my($p2) = $hinfo->{path};
           my($i2) = rindex($p2, ":");
           $p2 = substr($p2, 1, $i2-1);
           print "<br>controller=$p2<br>";
#          $TO::Hosts->[$hostno]{port_info}[$h]{sess} = $MAP1{$p2};
           
           $out .= "$hinfo->{LGroup}, Port:$hinfo->{PortWWN}, alpa=$hinfo->{al_pa}]\n";
           $out . "[       $hinfo->{path}  ]\n";
           $devs = $devices{$host}{$h};
           foreach my $d (sort keys %$devs) {
               $dinfo = $devs->{$d};
               $out .= "    $dinfo->{DeviceID}: ";
               if ($dinfo->{ProductID}  =~ /Switch/) {
                   ($new, $current_sw) = TO->newSwitch($host, $dinfo);
                   $ip_port = -1 if ($new);
                   $portno = $dinfo->{sw_PortNum};
                   $TO::Switches->[$current_sw]{port_info}[$portno] = $dinfo;
                   $alpa = $dinfo->{sw_DevAlpas};
                   $alpa = substr($alpa,0,11) . "..." if (length($alpa) > 11);
                   $out .= "$dinfo->{ProductID} ";
                   $out .= "$dinfo->{sw_ipName} Register=$dinfo->{RegisterName}, port=$dinfo->{sw_PortNum} ";
                   $sw_type = TO->switchPortType($dinfo);

                    $dp_port = 0; $dp_switch = -1;
                    %dp_port = ();
                   if ($dinfo->{NodeWWN} =~ /^0+$/) {
                       $TO::Switches->[$current_sw]{port}[$portno] = 0;
                      $out .= " not connected\n";
                   } else {
                      if (substr($sw_type,0,2) eq "ip") { # initiator, tie hba, to port
                         $TO::Hosts->[$hostno]{port}[$h] = "s:$current_sw:$portno";
                         $TO::Switches->[$current_sw]{port}[$portno] = "h:$hostno:$h";
                         $ip_port = $portno;
                      } else {
		         $dp_port = 1;
                         $DP2OBJ[$dinfo->{DeviceID}] = $portno;
                         $dp_switch = $current_sw;
                         if ($ip_port >= 0) {
                           $TO::Switches->[$current_sw]{dport}[$portno] = 
                                  "s:$current_sw:$ip_port";
                         }
                         
                      }
                      $out .= "al_pa=$alpa \n";
                   }
               } else {
                  next if ($dinfo->{LGroup} =~ /-Internal-/); # internal disk
                  ($new, $st_port, $st_type, $current_st) = TO->newStorage($host, $dinfo ,$h);
                  my($connect) = 1; my($vol) = 0;
                  if ($st_type eq "t") {
                    my($i) = $TO::Storages->[$current_st];
                    $i->{info}{volCount} = (defined($i->{info}{volCount})) ? 
                             $i->{info}{volCount}+1: 0;

                    my($vol) = $i->{info}{volCount};
   	            $i->{vol_info}[$vol] = $dinfo;
                    $i->{info}{vols} .= "$dinfo->{SerialNo},";
                    if ($dinfo->{PortMode} =~ /Alternate/) {
                      $i->{info}{PG} = 1 ;
                      $connect = 0;
                    }

                  } else {
                    if ($st_type eq "a" && $dinfo->{RegisterName} =~ /\-ses(\d+)/) {
                        if (! $TO::Storages->[$current_st]{ses_info}[$st_port]) {
                          $TO::Storages->[$current_st]{ses_info}[$st_port] = $dinfo;
                        }
                        my($ii) = $TO::Storages->[$current_st]{info};
                        my($pp) = ($st_port==0)? "A":"B";
                        if (!$ii->{"ses_$pp"}) {
                           $ii->{"ses_$pp"} = $MAP1{$p2};
                           print "$dinfo->{BoxName} assigning $pp to $p2<br>";
                        }
                    }
                  }

                  if ($dp_port && !$dp_port{$current_st}) { # switch port goes to storage
                     if ($connect) {
                         $dp_port{$current_st} = 1;
                         my($parent) = $DP2OBJ[$dinfo->{Parent}];
                         # attach device to switch, or to hub-switch if needed
                         &addNode($host, "s",$TO::Switches, $dp_switch, $parent, $st_type, 
                                  $current_st, $st_port,"$dp_switch-$parent");
                     }
                   } else {
                        my($disk) = $dinfo->{RegisterName};
                        if ($new) {
                           # attach device to host, or to hub-switch if needed
                           &addNode($host, "h",$TO::Hosts, $hostno, $h, $st_type, $current_st, 
                                    $st_port, "$host/$h");
                        }
                        if ($st_type eq "a") { # a5k extra disks
#                           $TO::Storages->[$current_st]{ses_info}[0] = $dinfo;
                           my($i) = index($disk, "-");
                           $disk = substr($disk, $i+1);
                           if (substr( $dinfo->{VendorID},0,1) eq "\"") {
                                 $dinfo->{VendorID} = substr($dinfo->{VendorID},1,-1);
                           }
                           $TO::Storages->[$current_st]{disk_info}{$disk} = {
                              PortWWN => $dinfo->{PortWWN},
                              NodeWWN => $dinfo->{NodeWWN},
                              LogicalPath => $dinfo->{LogicalPath},
                              FirmwareRev => $dinfo->{FirmwareRev},
                              sf_al_pa => $dinfo->{sf_al_pa},
                              VendorID => $dinfo->{VendorID},
                              SerialNo => $dinfo->{SerialNo},
                              RegisterName => $dinfo->{RegisterName},
                           }
                        } elsif ($st_type eq "t") {
                           my($x) = 0;
                        } else {
	   	           $TO::Storages->[$current_st]{disk_info}{$disk} = $dinfo;
                        }
                   }
                      
               }
           }
       }
    }
  }
#  distribute volume info to the partner group
  if (0) {
  foreach my $wwn (keys %PG) {
     my($p) = $PG{$wwn};
     my($master) = $PGM{$wwn}{M};
     $TO::Storages->[$master]{info}{PG} = $wwn;

     my($slaves) = $PGM{$wwn}{S};
     my(@slave) = split(/,/, $slaves);
     foreach my $sl (@slave) {
        $TO::Storages->[$sl]{info}{PG} = $wwn if ($sl);
     }

     my($x);
     my($cnt) = $p->[0];
     for ($x=1; $x <= $cnt; $x++) {
       my($s) = $TO::Storages->[$master]{vol_info};
       my($pos) = $#$s + 1;
       $TO::Storages->[$master]{vol_info}[$pos] = $p->[$x];
     }
  }
  }
  return $out;
}

sub addNode {
  my($host, $hubType, $TO,  $hub_no, $hub_port, $st_type, $current_st, $st_port, $hubname) = @_;
  my($current_hub);
  my($a1) =  $TO->[$hub_no]{port}[$hub_port];
  if ($a1) {
      my(@a11) = split(/:/, $a1);
      if ($a11[0] eq "u") { # already a hub, use it
          my($no) =  $TO::Hubs->[$a11[1]]{port};
          $no = $#$no + 1;
          $TO::Hubs->[$a11[1]]{port}[$no] =  "$st_type:$current_st:$st_port";
          $TO::Storages->[$current_st]{ses}[$st_port] = "u:$a11[1]:$no";
      } else {              # create a hub.
          $current_hub = TO->newHub($host, $hubname);
          $TO->[$hub_no]{port}[$hub_port] = "u:$current_hub:0";
          $TO::Hubs->[$current_hub]{port}[0] = "$hubType:$hub_no:$hub_port";

          $TO::Hubs->[$current_hub]{port}[1] = $a1;
          $TO::Storages->[$a11[1]]{ses}[$a11[2]] = "u:$current_hub:1";

          $TO::Hubs->[$current_hub]{port}[2] =  "$st_type:$current_st:$st_port";
          $TO::Storages->[$current_st]{ses}[$st_port] = "u:$current_hub:2";
      }
  } else {
      $TO->[$hub_no]{port}[$hub_port] = "$st_type:$current_st:$st_port";
      $TO::Storages->[$current_st]{ses}[$st_port] = "$hubType:$hub_no:$hub_port";
  }
}


1;
