package GUI::Hosts;
#  $Id: Hosts.pm,v 1.24 2001/09/28 02:56:30 ccadieux Exp $

use Net::Ping;
use Util::Http;
use System;
use GUIAdmin;

sub list {
  my($q) = @_;
  my($ho, $o);

  print "\n";
  if ( Util->findMaster()) {
    print "<body bgcolor=white><h1><center>This function is not allowed on a slave!";
    return;
  }


  if ($q->{ACTION} eq "Add a new Slave") {
     &add($q);
     return;
  } elsif ($q->{ACTION} eq "Push Slave Configs") {
     &push_slaves($q);
  }
  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
  my($ping) = ($q->{ACTION} eq "Ping Slaves")? 1:0;
  $head = &main::header("Maintain Hosts","","","masterconfig");

  for ($x=0; $x <= $#$dev; $x++) {
    $h = $dev->[$x];
    if ($h->{host}) {
       $X{$h->{host}}++;
    } else {
       $dev_cnt++;
    }
  }
  my($flag) =0;
  for ($x=0; $x <= $#$host; $x++) {
    $h = $host->[$x];
    $lnk = "<a href=/?GO=GUI::Hosts::upd&no=$x><b>$h->{hostname}</b></a>";
    use Net::Ping;
    $p = Net::Ping->new();

    $alive = "";
    if ($ping) {
      if ($h->{active} eq "N") {
        $alive = "(Inactive)";
      } else {
        print "Pinging $h->{ip}...<br>";
        $ix = index($h->{ip}, ":");
        $ip = ($ix > 0)? substr($h->{ip},0,$ix) : $h->{ip};
        eval {
          $alive   = ($p->ping($ip,4))? "Alive":"Unaccessible";
        };
        $url     = Util->makeUrl($h->{ip}, "?GET=hostid");
        $hostid = Util::Http->get($url, $main::TO) || "Error";
        if ($hostid ne "Error") {
          $h->{hostid} = $hostid if (!$h->{hostid});
        }
      }
    }
    $cnt = $X{$h->{hostname}} + 0;
#    use POSIX2;
    $push = $h->{last_push};
    $flag++ if (!$push);
#    if ($h->{last_push}) {
#       $push .= POSIX::strftime("%b", 0,0,0,0,substr($h->{last_push},0,2),0) 
#                . substr($h->{last_push},2);
#    }

    $active = $h->{active} || "N";
    $x2 = "&nbsp;$alive";
    $x2 .= "/ $hostid" if ($hostid);
    if ($push =~ /FAILED/) {
      $push = "<td bgcolor=#F0D0D0>&nbsp;$push</td>";
    } else {
      $push = "<td>&nbsp;$push</td>";
    }
    $ho .= "<tr>
                <td>$lnk</td>
                <td>Slave</td>
                <td>$h->{hostid}</td>
                <td>$h->{ipno}</td>
                $push
                <td><center>$active</td>
                <td>$x2</td>
          ";
  }
  if ($ping) {
      PDM::ConfigFile->write( $renv, $dev, $host,$notifs);
  }
  $comment= "";
  if ($flag && $#$host  >= 0) {
    $comment = "<font color=red size=+2>$flag slave(s) need to be updated. Use [Push Slave Configs]</font>.";
  }

  $hid = `/usr/bin/hostid`; chop($hid);
  $hname = System->hostname;
  $ip = System->local_ip;

  if ($#$host < 0) {
     $ho .= "<tr><td colspan=7><br>No registered slaves present.</td>";
  }
  $x = &main::read_file("host_registration");
  $local_active = (-f System->get_home() . "/DATA/start")? "Y":"N";
  $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<form  method=get>
 <input type=hidden name=GO value=GUI::Hosts::list>
<center>
$head
$x
$q->{ERR}
&nbsp;
<table border=1 cellspacing=0 width=90% bgcolor=white><tr><td>
<table border=0 cellpadding=2 cellspacing=2 width=100% bgcolor=#F0F0F0>
<tr><td colspan=7 bgcolor=#666699><b><font color=white>&nbsp;Existing Hosts</td>
<tr>
    <td bgcolor=$main'LIGHT><center><b>HostName</td>
    <td bgcolor=$main'LIGHT><center><b>Type</td>
    <td bgcolor=$main'LIGHT><center><b>HostID</td>
    <td bgcolor=$main'LIGHT><center><b>Host IP</td>
    <td bgcolor=$main'LIGHT><center><b>Last Push</td>
    <td bgcolor=$main'LIGHT><center><b>Active</td>
    <td bgcolor=$main'LIGHT><center><b>Ping / Hostid</td>
<tr>
    <td><b><a href=?GO=GUI::Config::upd>$hname</a></td>
    <td><b>Master<b></td>
    <td>$hid<b></td>
    <td>$ip</td>
    <td>&nbsp;N/A</td>
    <td><center>$local_active</td>
    <td>&nbsp;</td>
$ho
</table>
</table>
&nbsp;<br>
<b>
<input type=submit name=ACTION value="Add a new Slave">
<input type=submit name=ACTION value="Ping Slaves">
<input type=submit name=ACTION value="Push Slave Configs">
</form>
$comment
EOF

print $o;
}


sub push_slaves {
  my($q, $hostlist) = @_;

  ($renv, $dev, $hosts,$notifs) = PDM::ConfigFile->read();
  foreach $h (@$hosts) {
     next if ($hostlist and index(",$hostlist," , ",$h->{hostname},") < 0);

#       if ($h->{active} eq "N") {
#          print "Skipping $h->{hostname} (Inactive) ... <br>";
#          next;
#       }
     print "Pushing Config to $h->{hostname} /$h->{ip} ... <br>";
     $config = PDM::ConfigFile->getSlaveConfig($h->{hostid});
     if (!$config) {
         print "Cannot find $h->{hostid} in configfile<br>";
         next;
     }
#     $url  = Util->makeUrl($h->{ip}, "?PUT=config");
     $url  = Util->makeUrl("$h->{ip}", "?PUT=saveF&file=rasagent.conf.push");
     ($err, $ans)  = Util::Http->post($url, $config, $TO);
     if (!$err) {
        print "&nbsp;&nbsp;--> succeeded: $ans<br>";
        $h->{last_push} = Util->today;
     } else {
        print "&nbsp;&nbsp;--> Failed: $ans!<br>";
        $h->{last_push} = "FAILED";
     }
  } 
  PDM::ConfigFile->write( $renv, $dev, $hosts, $notifs);
}



sub add {
  my($q) = @_;
  my($ho, $o, $err, $cat, $err1);

  print "\n";
  my($categories) = &main::findSelectableAgents();

  if ($q->{ACTION} eq "Back") {
    &list($q);
    return;

  } elsif ($q->{ACTION} eq " Add ") {
    $q->{hostid} = lc($q->{hostid});
    while (1) {
#     if ($q->{ping}) {
#        @a = split(/ *[\n\r]+ */, $q->{ping});
#        $err1 = "";
#        foreach $p (@a) {
#           @l = split(/ *[\:\|\#] */, $p);
#           if (!(-d $l[0] || -f $l[0])) {
#              $err1 .= "Cannot read path: $l[0]<br>";
#           }
#        }
#     }
     if ($q->{hostid} eq System->hostid) {
        $err = &main::info("You cannot enter the hostid of the Master Host for a Slave!");
        last;
     } elsif ($err1) {
        $err1 = "<font color=red>$err1</font>";
        $err = &main::info("Error with data-ping information");
        last;
     } elsif (!$q->{hostname}) {
        $err = &main::info("You must enter a hostname <br>Record not added!");
        last;
     } else {
        $done = 0;
        if (index($q->{hostname} , ".") < 0) {
           $save = $q->{hostname};
           $q->{hostname} .= "." . lc(System->domain());
           $ipno = Util->name2ip($q->{hostname});
           if (!$ipno) {
             $q->{hostname} = $save;
           } else {
             $done = 1;
           }
        }
        if (!$done) {
          $ipno = Util->name2ip($q->{hostname});
          if (!$ipno) {
             $err = &main::info("Cannot ping this host: $q->{hostname}");
             goto out;
          }
        }

        ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
        foreach $x (@$host) {
          foreach $tag ('hostid','hostname') {  # ip
            if ($x->{$tag} eq $q->{$tag}) {
              $err = &main::info("This $tag was already used <br>Record not added!");
              goto out;
            }
          }
        }
        $x = $#$host + 1;
        $cat = "";
        foreach my $c (@$categories) {
          my(@bb) = split(/=/, $c);
          $cat .= "$bb[0]|" if ($q->{$bb[0]});
        }
        $url    = Util->makeUrl($q->{hostname}, "?GET=hostid");
        $hostid = Util::Http->get($url, 60) || "Error";

        if ($hostid ne "Error") {
           $host->[$x]{hostid}   = $hostid;
        } else {
           if ($q->{hostid} !~ /^\w\w\w\w\w\w\w\w$/ && lc(System->os) !~ /linux/) {
             $err = &main::info("Invalid Hostid, must enter 8 digits!");
             last;
           }
           $host->[$x]{hostid}   = $q->{hostid};
        }
        chop($cat) if ($cat);
        $host->[$x]{categories} = $cat;
        $host->[$x]{_name}    = "host" . ($x+1);
        $host->[$x]{hostname} = $q->{hostname};
        $host->[$x]{ip}       = $q->{hostname};
        $host->[$x]{active}   = "N";
        $host->[$x]{ipno}     = Util->name2ip($q->{hostname});
         $host->[$x]{solution} = $q->{solution} ? "Y":"N";
        $host->[$x]{frequency}= $q->{frequency} || 10;
        $host->[$x]{contract} = $q->{contract} if ($q->{contract});
        $host->[$x]{logfile}  = "/var/adm/messages";
        $host->[$x]{t300logfile} = $q->{t300logfile} ;
        $host->[$x]{st4logfile} = $q->{st4logfile} ;
#        $q->{ping} =~ s/ *[\|\:\#]+ */#/g;
#        $q->{ping} =~ s/ *[\n\r]+ */|/g;
#        $host->[$x]{ping}       = $q->{ping};

        GUIAdmin->clearSlave($q->{hostname}, $host);

        if (!PDM::ConfigFile->write( $renv, $dev, $host,$notifs)) {
           print "Cannot write to ConfigFile $CONF<br>";
        } else {
           $info = &main::info("Host added!");
#           &main::save_event("AH", $q->{hostid});
           print "Added";
        }
        &list($q);
        return;
     }
     last;
    }
  }
out:

  $h = &main::header("Maintain Hosts: Add New Slave");
  $q->{logfile}     = "/var/adm/messages";
#  $q->{t300logfile} = "/var/adm/messages.t3" if (!$q->{t300logfile} && !$err);
  $q->{st4logfile} = "/var/opt/SUNWvtsst/logs";

  my($modules_html) = "";
  foreach my $mod (@$categories) {
     my(@bb) = split(/=/, $mod);
     my($ck) = "checked" if ($q->{$bb[0]});
     $modules_html .= "<input type=checkbox name=$bb[0] $ck>:$bb[1]&nbsp; ";
  }
  $frequency = &main::select_frequency($q);

  $o =<<EOF;
<body bgcolor=#F0F0F0>
<form  method=get>
 <input type=hidden name=GO value=GUI::Hosts::add>
<center>
$h
$err
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr><td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;Enter Host Information</td>
<tr><td bgcolor=$main'LIGHT width=30% align=right>HostID :</td>
    <td><input type=text name=hostid size=8 maxlength=8 value="$q->{hostid}">
<tr><td bgcolor=$main'LIGHT width=30% align=right>Host Name:</td>
    <td><input type=text name=hostname size=40 maxlength=40 value="$q->{hostname}">

<tr><td bgcolor=$main'LIGHT align=right nowrap>Special Contract:</td>
    <td><input type=ip size=20 maxlength=20 name=contract value="$q->{contract}">

<tr><td bgcolor=$main'LIGHT align=right>
     &nbsp;Categories to Monitor: </td>
    <td>
   $modules_html
 </td>
<tr><td bgcolor=$main'LIGHT align=right>
     &nbsp;Monitoring Frequency: </td>
    <td>$frequency</td>
<tr>
<td bgcolor=$main'LIGHT align=right>SE Series?: </td>
    <td ><input type=checkbox name=solution $solution></td>


<tr><td colspan=2 bgcolor=silver><b>&nbsp;Enter Logfiles Locations</td>
<tr><td bgcolor=$main'LIGHT align=right>Message Log:</td>
    <td><table border=1 cellspacing=0><tr><td>$q->{logfile}</table></td>
<tr><td bgcolor=$main'LIGHT align=right>T3 Message Log:</td>
    <td><input type=text name=t300logfile size=50 maxlength=60 value="$q->{t300logfile}">
<tr><td bgcolor=$main'LIGHT align=right>Stortools4 Log Directory:</td>
    <td colspan=3><input type=text name=st4logfile size=50 maxlength=60 
      value="$q->{st4logfile}">


</table>
</table>
<b>
<input type=submit name=ACTION value=" Add ">
<input type=submit name=ACTION value="Back">
</form>
EOF

  print $o;

}

#<tr><td colspan=2 bgcolor=silver><b>&nbsp;Enter DataPing Directories (One dir/file per line)</td>
#<tr><td colspan=2>$err1
#      <textarea name=ping cols=60 rows=12>$q->{ping}</textarea></td>

sub upd {
  my($q) = @_;
  my($ho, $o);
  my($name, $err);

  print "\n";
  my($categories) = &main::findSelectableAgents();

  if ($q->{ACTION} eq "Back") {
    &list($q);
    return;
  } elsif ($q->{ACTION} eq "Delete") {
    ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
    $x = $q->{no};
    $hostid = $host->[$x]{hostid};
    $host->[$x]{_name} = "";
    unlink System->get_home() . "/DATA/REMOTE_LISTS/" . $host->[$x]{hostname};

    $name = $host->[$x]{hostname} . "/ " . $host->[$x]{ip};
    PDM::ConfigFile->write( $renv, $dev, $host,$notifs);
    &main::log_change("Slave Host $name deleted");
    $q->{ERR} = &main::info("Host $name deleted!");
    &main::save_event("DH", $hostid);

    $url =  Util->makeUrl($host->[$x]{ip}, "?GET=DELET&file=start");
    $rc = Util::Http->get($url, 30);


    &list($q);
    return;

  } elsif ($q->{ACTION} eq " Update ") {
    $q->{hostid} = lc($q->{hostid});
    while (1) {
#     if ($q->{ping}) {
#        @a = split(/ *[\n\r]+ */, $q->{ping});
#        $err1 = "";
#        foreach $p (@a) {
#           @l = split(/ *[\:\|\#] */, $p);
#           if (!(-d $l[0] || -f $l[0])) {
#              $err1 .= "Cannot read path: $l[0]<br>";
#           }
#        }
#     }
     if ($err1) {
        $err1 = "<font color=red>$err1</font>";
        $err = &main::info("Error with data-ping information");
        last;
     } elsif ($q->{hostid} eq System->hostid) {
        $err = &main::info("You cannot enter the hostid of the Master Host for a Slave!");
        last;
     } else {
        ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
        $x = $q->{no};
        $cat = "";
        foreach my $c (@$categories) {
          my(@bb) = split(/=/, $c);
          $cat .= "$bb[0]|" if ($q->{$bb[0]});
        }
        chop($cat) if ($cat);

        my($H) = $host->[$x];
        if ($H->{categories} ne $cat) {
          &main::log_change("Monitored categories on Slave:$H->{hostname} changed from '$H->{categories}' to '$cat'");
        }
        $host->[$x]{categories} = $cat;

        $host->[$x]{solution} = $q->{solution}? "Y":"N";
        $host->[$x]{last_push}  = "";
        $host->[$x]{contract} = $q->{contract};
        if ($H->{frequency} ne $q->{frequency}) {
           &main::log_change("Monitoring Frequency on Slave:$H->{hostame} changed from '$H->{frequency}' to '$q->{frequency}'");
        }
        $host->[$x]{frequency}= $q->{frequency} || 5;
        $host->[$x]{logfile}  = "/var/adm/messages";
        $host->[$x]{t300logfile} = $q->{t300logfile} ;
        $host->[$x]{st4logfile} = $q->{st4logfile} ;
#        $q->{ping} =~ s/ *[\|\:\#] */#/g;
#        $q->{ping} =~ s/ *[\n\r]+ */|/g;
#         $host->[$x]{ping}       = $q->{ping};

        GUIAdmin->clearSlave($host->[$x]{hostname}, $host);

        if (!PDM::ConfigFile->write( $renv, $dev, $host,$notifs)) {
           print "Cannot write to ConfigFile $CONF<br>";
        } else {
           $err = &main::info("Host Updated! <font color=red>(Need to Push-Configs)</font>","green");
        }
     }
     last;
    }
  }
out:

  $h1 = &main::header("Maintain Hosts: Update Host");

  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
  $h = $host->[$q->{no}];

  my($modules_html) = "";
  foreach my $mod (@$categories) {
     my(@bb) = split(/=/, $mod);
     my($ck) = "checked"  if (index($h->{categories}, $bb[0]) >= 0);
     $modules_html .= "<input type=checkbox name=$bb[0] $ck>:$bb[1]&nbsp; ";
  }
  $ping = $h->{ping};
  $ping =~ s/\|/\n/g;
  $ping =~ s/#/  #/g;
  $frequency = &main::select_frequency($h);
  $active = ($h->{active} eq "Y")? "Yes":"No";
  my $solution = ($h->{solution} eq "Y")? "checked":"";

  $o =<<EOF;
<body bgcolor=#F0F0F0>
<form  method=get>
 <input type=hidden name=GO value=GUI::Hosts::upd>
 <input type=hidden name=no value=$q->{no}>
 <input type=hidden name=hostid value=$h->{hostid}>
<center>
$h1
$err
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr><td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;Update Host Information</td>
<tr><td bgcolor=$main'LIGHT width=20% align=right>HostID :</td>
    <td><table border=1 cellspacing=0><tr><td>$h->{hostid}&nbsp;</table>
<tr><td bgcolor=$main'LIGHT width=20% align=right>Host Name :</td>
    <td>&nbsp;<b>$h->{hostname}</td>

<tr><td bgcolor=$main'LIGHT align=right >IP Number&nbsp;:</td>
    <td><b>&nbsp;$h->{ipno}

<tr><td bgcolor=$main'LIGHT align=right>Special&nbsp;Contract&nbsp;:</td>
    <td><input type=ip size=20 maxlength=20 name=contract value="$h->{contract}">

<tr><td bgcolor=$main'LIGHT align=right>&nbsp;Categories to Monitor: </td>
    <td >
    $modules_html
 </td>
<tr><td bgcolor=$main'LIGHT align=right>
     Monitoring&nbsp;Frequency: </td>
    <td>$frequency</td>
<tr><td bgcolor=$main'LIGHT align=right>SE Series?: </td>
    <td ><input type=checkbox name=solution $solution></td>
<tr><td bgcolor=$main'LIGHT align=right>
     Host is Active: </td>
    <td>$active</td>

<tr><td colspan=2 bgcolor=silver><b>&nbsp;Enter Default Logfiles</td>
<tr><td bgcolor=$main'LIGHT align=right>Message Log :</td>
    <td><table border=1 cellspacing=0><tr><td>$h->{logfile}</table></td>
<tr><td bgcolor=$main'LIGHT align=right>T3 Message Log :</td>
    <td><input type=text name=t300logfile size=50 maxlength=60 value="$h->{t300logfile}">
<tr><td bgcolor=$main'LIGHT align=right>Stortools4 Log Directory:</td>
    <td colspan=3><input type=text name=st4logfile size=50 maxlength=60 
      value="$h->{st4logfile}">

</table>
</table>
<b>
<input type=submit name=ACTION value=" Update ">
<input type=submit name=ACTION value="Delete">
<input type=submit name=ACTION value="Back">
</form>
EOF

  print $o;
}

#<tr><td colspan=2 bgcolor=silver><b>&nbsp;Enter DataPing Directories (One dir/file per line)</td>
#<tr><td colspan=2>$err1
#      <textarea name=ping cols=60 rows=12>$ping</textarea></td>
1;
