package GUI::Thresholds;
#  $Id: Thresholds.pm,v 1.9 2001/07/26 00:41:45 ccadieux Exp $


use PDM::Thresholds;

sub th {
  my($q) = @_;
  print "\n<body bgcolor=$main'BGCOLOR><center>";
  $h = &main::header("Thresholds");

  $o =<<EOF;
<form  method=get>
 <input type=hidden name=GO value=th>
<center>
$h
<table border=0 width=90% bgcolor=white><tr><td>
This page lists all threshold rules. The 'Frequency' is the number of alerts/hours required to generate a new message/email. The 'Quiet' value refers to the quiet time in between messages, used to avoid sending too many emails. Text in blue gives information about last message date or about the current number of alerts found against a specific threshold key. This text will appear only after the Network Storage Agent ran for a while.
</table>
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100% bgcolor=#F0F0F0>
<tr><td colspan=6 bgcolor=#666699><b><font color=white>Thresholds</td>
<tr bgcolor=$main'LIGHT>
   <th>Name</th>
   <td colspan=2><b>&nbsp;Frequency</td>
   <td><b>&nbsp;Quiet</td>
   <th>Type</th>
   <th>Desc</th>
EOF


  ($data, $th) = PDM::Thresholds->new()->init();

  open(O, System->get_home() ."/System/SW_Thresholds");
  while ($l = <O>) {
    chop($l);
    next if ($l =~ /^ *$/ or substr($l,0,1) eq "#");
    next if (substr($l,0,1) eq "'");
    @a = split(/ *[\.\=\,] */, $l);
    $freq = $a[3];
    $repeat = $a[4];
    $type = ($a[5] eq "W")? "Warning":"Error";
    $unit = ($a[3] =~ /m$/) ? "ins":"ours";
    $unit2 = ($repeat =~ /m$/) ? "ins":"ours";
    $o .= "<tr>
         <td>$a[0].$a[1]</td>
         <td><center>$a[2]</td>
         <td>/ $a[3]$unit</td>
         <td>$repeat$unit2</td>
         <td><center>$type</td>
         <td>&nbsp;$a[6]</td>
         ";
    $p = $data->{$a[0]}{$a[1]};
    $xx = 0;
    foreach $k (keys %$p) {
      $v  = $p->{$k};
      $xx++;
      $d1 = Util->get_date($v->[0]*60);
      if ($v->[1] == 0) {
        $text = "Last message on $d1";
      } else {
        $text = "Received $v->[1] since $d1";
      }
      $o .= "<tr><td bgcolor=white align=right><font color=navy><b>$k:</td>
              <td colspan=5 bgcolor=white><font color=navy>$text</td>";
    }
    $o .= "<tr><td></td>" if ($xx);
  }
  $o .= "</table></table>";
  print $o;
}

1;
