package _DiskInq;
#  $Name:  $ 
#  $Id: _DiskInq.pm,v 1.7 2001/02/16 19:28:32 ccadieux Exp $

use System;
use base 'Agent';
sub isSelectable {0}
sub revision {'$Revision: 1.7 $'}

sub new {
  my($self) = Agent->new();

  bless ($self, '_DiskInq');
  return $self;
}

sub RUN {
  my($agent, $ras_flag) = @_;
  my($line);
  my($pdm) = $agent->{pdm};
  return;

  my($err, $di) = Util->run_command(System->get_home() . "/bin/disk_inquiry 2>/dev/null", "di.txt", 30);
  if ($err) {
      Debug->err(CANNOT_RUN => "disk_inquiry", $err);
      return;
  }
  my($cnt)= 0;
  my($dno, $l);
  my($DI) = $pdm->getGlobal("disk_inquiry");
  foreach $line (@$di) {
     next if ($cnt++ < 4);
     if ($line =~ / *(\d+): (.*)/) {
       $dno = $1; $l = $2;
       my(@a) = split(/\s+/, $l);
       if ($a[2] eq "T300") {
          $a[4] =~ s/\#//g;
          $a[4] =~ s/^0+//g;
          $DI->{T3}{$a[4]} = $l;
       }
     }
  }

};

#
# NOT Used
#
sub _di {
  my($agent) = @_;
  my($l, %V);

  my($err,$com) = Util->run_command(
           "$agent->{home}/bin/disk_inquiry -dP 2>/dev/null",
           "di.txt");

  foreach $l (@$com) {
     $l =~ s/\0//g;
     next if ($l =~ /\tVendor\t/ || $l =~ /^ *$/ || $l =~ / SCSI DE/);
     @v = split(/ *\t */, $l);
     $ix = index($l,":");
     $no = substr($l,0,$ix) + 0;
# FIELDS: device, vendor, product, type, type, revision , serial, port

     $V{"disk.$no.revision"} = $v[2];
     $c = Util->ltrim($v[0]);
     $c = $1 if ($v[0] =~ /\d+: (.*)/);
     $V{"disk.$no.no"}         = $no;
     $V{"disk.$no.controller"} = $c;
     $V{"disk.$no.id"}         = $c;
     $V{"disk.$no.dual_port"} = Util->rtrim($v[4]);              #port
     $V{"disk.$no.serial"} = $v[3];
     $V{"disk.$no.serial"} =~ s/\#//g;                      #serial
     if (substr($V{"disk.$no.serial"},0,1) eq "0") {
       $V{"disk.$no.serial"} =~ /0+(.*)/;
       $V{"disk.$no.serial"} = $1;
     }
     $x = index($v[1]," ");
     if ($x >= 0) {
        $V{"disk.$no.vendor"} = substr($v[1],0,$x);
        $V{"disk.$no.product"} = Util->ltrim(substr($v[1],$x));
     } else {
        $V{"disk.$no.vendor"} = $v[1];
     }
     if ($v[1] =~ /T300/) {
       $V{"disk.$no.device_type"} = "T300";
     } elsif ($v[1] =~ /A3500/) {
       $V{"disk.$no.device_type"} = "A3500";
     } elsif ($v[5] =~ /\/ssd\@/) {
       $V{"disk.$no.device_type"} = "A5000";
     } else {
       $V{"disk.$no.device_type"} = "local";
     }
  }
#  return $agent->getXML(\%V);
}


1;
