package GUI::Notifs;
#  $Id: Notifs.pm,v 1.15 2001/07/26 00:41:45 ccadieux Exp $


sub list {
  my($q) = @_;
  my($ho, $o);

  print "\n";
  if ( Util->findMaster()) {
    print "<body bgcolor=white><h1><center>This function is not allowed on a slave!";
    return;
  }


  if ($q->{ACTION} eq "Add Notification") {
     &add($q);
     return;
  } 
  print "<body bgcolor=$main'BGCOLOR> <center>";
  print &main::header("Local Email/Pager Notifications","","","notifications");

  ($renv, $dev, $host, $notifs) = PDM::ConfigFile->read;

  for ($x=0; $x <= $#$notifs; $x++) {
    $h    = $notifs->[$x];
    $lnk  = "<a href=/?GO=GUI::Notifs::upd&no=$x><b>$h->{email}</b></a>";
    $type = $h->{type};
    $device = ($h->{device} eq "*")? "All": $h->{device};
    $prio   = ($h->{priority} eq "*")? "All": "$h->{priority}: $PRIO{$h->{priority}}";
    @a      = split(/\|/,  $h->{event});
    $events = "";
    foreach $x (@a) {
      if ($x eq "*") {
        $events .= "**All Events<br>";
      } else {
        $events .= "$x<br>";
      }
    }
    $ho .= "<tr>
                <td><center>$type</td>
                <td>$lnk</td>
                <td><center>$device</td>
                <td>$events</td>
                <td><center>$prio</td>
           ";
  }
  if ($#$notifs < 0) {
     $ho .= "<tr><td colspan=5><b>No Local Notifications were found.</td>";
  }
  $x    = &main::read_file("local_notification");
  $o =<<EOF;
<form  method=get>
 <input type=hidden name=GO value=GUI::Notifs::list>
$x
$q->{ERR}
<table border=2 cellspacing=1 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100% bgcolor=#F0F0F0>
<tr><td colspan=5 bgcolor=#666699><b><font color=white>&nbsp;Existing Local Notifications</td>
<tr>
    <td bgcolor=$main'LIGHT><center><b>Notif. Type</td>
    <td bgcolor=$main'LIGHT><center><b>Email (Click to Update)</td>
    <td bgcolor=$main'LIGHT><center><b>Category</td>
    <td bgcolor=$main'LIGHT><center><b>EventType</td>
    <td bgcolor=$main'LIGHT><center><b>Priority</td>
$ho
</table>
</table>
<b>
<input type=submit name=ACTION value="Add Notification">
</form>
EOF

print $o;
}

sub upd {
  my($q) = @_;
  my($ho, $o);
  my($name);

  print "\n";

  if ($q->{ACTION} eq "Back") {
    $q->{option} = "";
    &list($q);
    return;
  } elsif ($q->{ACTION} eq "Update") {
    if (!$q->{email}) {
        $err = &main::info("Email/File is Mandatory!");
        goto out;
    }
    ($renv, $dev, $host, $notifs) = PDM::ConfigFile->read;

    $x = $q->{no};
    $notifs->[$x]{email}  = $q->{email};
    $notifs->[$x]{device} = $q->{device};
    $notifs->[$x]{type}   = $q->{type};

    if (!$q->{event} || (index($q->{event}, "*") >= 0) ) {
       $notifs->[$x]{event}     = "*" ;
    } else {
       $s = $q->{event}; $s =~ s/\t/|/g;
       $notifs->[$x]{event}     = $s;
    }
    PDM::ConfigFile->write($renv, $dev, $host, $notifs);
    $err = &main::info("Notification updated", "green");

  } elsif ($q->{ACTION} eq "Delete") {
    ($renv, $dev, $host, $notifs) = PDM::ConfigFile->read;
    $x = $q->{no};
    $notifs->[$x]{_name} = "";
    $name = $notifs->[$x]{email};
    PDM::ConfigFile->write( $renv, $dev, $host, $notifs);
    $q->{ERR} = &main::info("Notification $name deleted!");
    &list($q);
    return;

  }
out:

  $h1 = &main::header("Notifications: Update Email");

  ($renv, $dev, $host, $notifs) = PDM::ConfigFile->read;
  $h = $notifs->[$q->{no}];

  $device = ($h->{device} eq "*")? "All": $h->{device};
  $prio   = ($h->{priority} eq "*")? "All": "$h->{priority}: $PRIO{$h->{priority}}";
  @a      = split(/\|/,  $h->{event});
  $events = "";
  %w = ();
  foreach $x (@a) {
    $w{'event_'.$x} = 1;
  }

  my($cat) = &main::find_devices();
  my($select) = "";
  foreach $c (@$cat) {
     $select .= lc($c)  ."=" . uc($c) . "|";
  }
  $select .= "Agent=StorageAgent|";
  chop($select) if ($select);
  $device   = "<select name=device>". &main::select("$select|*=All Devices", $h->{device});
  $events = "<select name=event size=12 multiple>".
              &main::select("*=All Events|" . &find_events , $h->{event}, 1);

  $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<form  method=get>
 <input type=hidden name=GO value=GUI::Notifs::upd>
 <input type=hidden name=no value=$q->{no}>
<center>
$h1
$err
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr><td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;Local Notification Information</td>

<tr><td bgcolor=$main'LIGHT align=right width=20%>Notification&nbsp;Type:</td>
    <td><b><input type=hidden name=type value=$h->{type}>&nbsp;$h->{type}</td>
  
<tr><td bgcolor=$main'LIGHT align=right width=20%>Email / Filename:</td>
    <td><input type=text name=email value="$h->{email}" size=40>
      <font color=red><big>*</td>

<tr><td bgcolor=$main'LIGHT align=right>Category:</td>
    <td><b>&nbsp;$device</td>

<tr><td bgcolor=$main'LIGHT align=right>Priority:</td>
    <td><b>&nbsp;$prio</td>

<tr><td bgcolor=$main'LIGHT align=right>Event Type:</td>
    <td><b>&nbsp;$events</td>


</table>
</table>
<b>
<input type=submit name=ACTION value="Update">
<input type=submit name=ACTION value="Delete">
<input type=submit name=ACTION value="Back">
</form>
EOF

  print $o;
}

sub add {
  my($q) = @_;
  my($ho, $o, $err);

  print "\n";

  if ($q->{ACTION} eq "Back") {
    $q->{option} = "";
    &list($q);
    return;

  } elsif ($q->{ACTION} eq " Add ") {
    while (1) {
     if ($q->{type} ne "File" && $q->{email} !~ /^.+\@.+/) {
        $err = &main::info("Invalid Email Format!");
        last;
     } else {
        ($renv, $dev, $host, $notifs) = PDM::ConfigFile->read;
        $x = $#$notifs + 1;
        $notifs->[$x]{_name}    = "notification" . ($x+1);
        $notifs->[$x]{email}    = $q->{email};
        $notifs->[$x]{device}   = $q->{device};
        $notifs->[$x]{type}     = $q->{type};
        $notifs->[$x]{priority} = $q->{priority};

        if (!$q->{event} || (index($q->{event}, "*") >= 0) ) {
          $notifs->[$x]{event}     = "*" ;
        } else {
          $s = $q->{event}; $s =~ s/\t/|/g;
          $notifs->[$x]{event}     = $s;
        }


        if (!PDM::ConfigFile->write($renv, $dev, $host, $notifs)) {
           print "Cannot write to ConfigFile $CONF<br>";
        } else {
           $info = &main::info("Notification added!", "green");
        }
        $q->{option} = "";
        &list($q);
        return;
     }
     last;
    }
  }
out:

  $h        = &main::header("Local Notification: Add New Entry");
  my($cat) = &main::find_devices();
  my($select) = "";
  foreach $c (@$cat) {
     $select .= lc($c)  ."=" . uc($c) . "|";
  }
  $select .= "Agent=StorageAgent|";
  chop($select) if ($select);
  $device   = "<select name=device ><option value=*>All Categories</option>" .
              &main::select($select, $q->{device});

  $priority = "<select name=priority ><option value=*>All Priorities</option>" .
              &main::select("1=High Priority|2=Medium|3=Low|9=High+Medium", $q->{priority});
  $ev       = "";
  $ev = &display_event_list($q, '-h');
  $evH = &display_event_list($q, 'h');

  $events = "<select name=event size=6 multiple><option value=*>All Events</option>" .
              &main::select(&find_events);

  $o =<<EOF;

<body bgcolor=$main'BGCOLOR>
<form  method=get>
 <input type=hidden name=GO value=GUI::Notifs::add>
<center>
$h
 <table border=0 cellpadding=2 bgcolor=white width=90%><tr><td>
  Create a notification record for each Administrator who would like to be notified of Network Storage Agent findings.   You can restrict the findings by Event Priority, Device Category and Event Type.   Multiple events can be selected and even sent to a pager if desired.  This flexibility allows for a customized alert notification scheme .

</table>&nbsp;
$err
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr><td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;Enter Local Notification Information</td>

<tr><td bgcolor=$main'LIGHT align=right width=20%>Notification Type:</td>
    <td><input type=radio name=type value=Email checked> Email &nbsp;&nbsp;
        <input type=radio name=type value=Pager> Pager &nbsp;&nbsp;
    </td>

<tr><td bgcolor=$main'LIGHT align=right width=20%>Email Address/&nbsp; Filename:</td>
    <td><input type=text name=email size=40 maxlength=60 value="$q->{email}">
<tr><td bgcolor=$main'LIGHT align=right>Priority:</td>
    <td>$priority</td>


<tr><td bgcolor=$main'LIGHT align=right>Category:</td>
    <td>$device</td>

<tr><td bgcolor=$main'LIGHT align=right>Event Type:</td>
    <td>$events</td>

</table>
</table>
<b>
<input type=submit name=ACTION value=" Add ">
<input type=submit name=ACTION value="Back">
</form>
EOF

  print $o;

}

sub display_event_list {
  my($q, $filter) = @_;
  my($x, $ck, $out);

  foreach $x (sort keys %{Event->get_types} ) {
     if (substr($filter,0,1) eq "-") {
        next if (Event->get_category($x) eq substr($filter,1));
        $ck = ($q->{"event_$x"})? "checked":"";
        $out .= "<input type=checkbox name=event_$x $ck>: " .
             Event->get_description($x) . "<br>";

     } else {
       if (Event->get_category($x) eq $filter) {
         $ck = ($q->{"event_$x"})? "checked":"";
         $out .= "<input type=checkbox name=event_$x $ck>: " .
             Event->get_description($x) . "<br>";
       }
     }
  }
  return $out;
}

sub find_events {
  open(O, System->get_home() . "/System/Events.list");
  my($out);
  while ($l = <O>) {
    chop($l);
    $out .= "$l=$l|";
  }
  close(O);
  chop($out);
  return $out;
}



1;
