package Timelapse;
#  $Name:  $ 
#  $Id: Timelapse.pm,v 1.4 2001/05/18 00:14:56 ccadieux Exp $

use Data::Dumper;


%DATA = ();

sub start {
  my($o, $module) = @_;

  $DATA{$module}[0] = time;
  $DATA{$module}[1] = 1;
}

sub stop {
  my($o, $module) = @_;
  
  if ($DATA{$module}[1] == 1) {
    $DATA{$module}[0] = time - $DATA{$module}[0];
    $DATA{$module}[1] = 2;
  }
}


sub save_all {
  my($o, $module) = @_;
  my($VAR1);
  my($F) = System->get_home() . "/DATA/timelapse.data";

  open(O,$F);
  my @a = <O>; close(O);
  eval "@a";

  foreach $m (keys %DATA) {
     if ($DATA{$m}[1] == 2) {
       $VAR1->{$m}{avg}[0]++;
       $VAR1->{$m}{avg}[1] += $DATA{$m}[0];
       $VAR1->{$m}{last}[0] = 1;
       $VAR1->{$m}{last}[1] = $DATA{$m}[0];
     }
  }

  open(O, ">$F");
  print O Dumper($VAR1);
  close(O);

}


sub readAll {
  my($o,$host) = @_;
  my($F, $out, $VAR1);

  if (!$host) {
    $F = System->get_home() . "/DATA/timelapse.data";
    open(O,$F);
    my @a = <O>; close(O);
    eval "@a";
    return $VAR1;
  } else {
     my $url =  Util->makeUrl($host, "?GET=FILER&file=timelapse.data");
     my $data = Util::Http->get($url, 20);
     eval $data;
     return $VAR1;
  }
}



sub clear {
  my($o) = @_;
  my($F) = System->get_home() . "/DATA/timelapse.data";
  my(%D);

  unlink $F;
}


1;
